package stackjava.com.hibernateversion.dao;

import java.util.List;

import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.cfg.Configuration;

import stackjava.com.hibernateversion.entities.Customer;

public class CustomerDAO {
	SessionFactory sessionFactory = new Configuration().configure().buildSessionFactory();
	
	public void save(Customer customer) {
		Session session = sessionFactory.openSession();
		try {
			session.beginTransaction();
			session.save(customer);
			session.getTransaction().commit();
			System.out.println("saved!");
		} catch (RuntimeException e) {
			session.getTransaction().rollback();
			e.printStackTrace();
		} finally {
			session.flush();
			session.close();
		}
	}

	public Customer findById(int id) {
		Session session = sessionFactory.openSession();
		Customer customer = session.load(Customer.class, id);
		System.out.println(customer);
		session.close();
		return customer;
	}

	public void showAll() {
		Session session = sessionFactory.openSession();
		List<Customer> list = session.createQuery("FROM Customer").list();
		for (Customer customer : list) {
			System.out.println(customer);
		}
		session.close();
	}

	public void update(Customer customer) {
		Session session = sessionFactory.openSession();
		try {
			session.beginTransaction();
			session.update(customer);
			session.getTransaction().commit();
			System.out.println("updated!");
		} catch (RuntimeException e) {
			session.getTransaction().rollback();
			e.printStackTrace();
		} finally {
			session.flush();
			session.close();
		}
	}

	public void delete(Customer customer) {
		Session session = sessionFactory.openSession();
		try {
			session.beginTransaction();
			session.delete(customer);
			session.getTransaction().commit();
			System.out.println("deteted!");
		} catch (RuntimeException e) {
			session.getTransaction().rollback();
			e.printStackTrace();
		} finally {
			session.flush();
			session.close();
		}
	}

}
